% Example design of a controller for the linear servo.
% The user can specify the controller poles and zeros, and the
% desired crossover frequency, and controllers and closed-loop transfer
% functions are calculated.


% Specify feedback controller here:
C=1; % Change to your desired controller! 

% Loop gain L(s), open-loop system
L=C*P;

% Plot Bode diagram of L(s) with phase- and gain margins
figure(2)
hold off
margin(L);

% Specify feedforward filter here:
F=1; % Change to your desired feedforward filter!

% Define process model for simulation
P_sim=P;


% Uncomment these lines to run the Simulink model for the simulated plant
% and then evaluate the results
% sim('servo_simulated')
% specs;


% -----------------------------------------------------------------

% Calculate all relevant closed-loop transfer functions from the
% process and controller data.
S=1/(1+L); % Sensitivity function
G_yr=1-S; % r -> y
G_yd=feedback(P,C); % d -> y
G_yn=S; % n -> x
G_ur=feedback(C,P); % r -> u
G_un=-G_ur; % n -> u
G_ud=-G_yr; % d -> u
